let _ = Mltop.add_known_module "coq-simple-io.plugin"

# 3 "plugin/coqsimpleio.mlg"
 
open Stdarg
open IOLib

let run_ast = mk_ref "SimpleIO.IO_Monad.IO.unsafe_run'"

let run c =
  Feedback.msg_info (Pp.str ("Running " ^ string_of_constr_expr c ^ " ..."));
  run ~plugin_name:"coq_simple_io"
    (CAst.make @@ apply_constr run_ast [c])

let string_unopt = function
  | None -> ""
  | Some s -> s


let () = Vernacextend.static_vernac_extend ~plugin:(Some "coq-simple-io.plugin") ~command:"RunIO" ~classifier:(fun _ -> Vernacextend.classify_as_sideeff) ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_constr), 
                                     Vernacextend.TyNil)), (let coqpp_body c
                                                           () = Vernactypes.vtdefault (fun () -> 
                                                                
# 20 "plugin/coqsimpleio.mlg"
                            run c
                                                                ) in fun c
                                                           ?loc ~atts ()
                                                           -> coqpp_body c
                                                           (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Include", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil))), (let coqpp_body s
                                                           () = Vernactypes.vtdefault (fun () -> 
                                                                
# 21 "plugin/coqsimpleio.mlg"
                                       add_extra_dir s 
                                                                ) in fun s
                                                           ?loc ~atts ()
                                                           -> coqpp_body s
                                                           (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Open", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil))), (let coqpp_body s
                                                           () = Vernactypes.vtdefault (fun () -> 
                                                                
# 22 "plugin/coqsimpleio.mlg"
                                    add_module_to_open s 
                                                                ) in fun s
                                                           ?loc ~atts ()
                                                           -> coqpp_body s
                                                           (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Package", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil))), (let coqpp_body s
                                                           () = Vernactypes.vtdefault (fun () -> 
                                                                
# 23 "plugin/coqsimpleio.mlg"
                                       add_extra_pkg s 
                                                                ) in fun s
                                                           ?loc ~atts ()
                                                           -> coqpp_body s
                                                           (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Builder", 
                                    Vernacextend.TyTerminal ("Ocamlfind", 
                                    Vernacextend.TyNonTerminal (Extend.TUopt (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))), (let coqpp_body opts
                                                            () = Vernactypes.vtdefault (fun () -> 
                                                                 
# 24 "plugin/coqsimpleio.mlg"
                                                          set_builder (Ocamlfind (string_unopt opts)) 
                                                                 ) in fun opts
                                                            ?loc ~atts ()
                                                            -> coqpp_body opts
                                                            (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Builder", 
                                    Vernacextend.TyTerminal ("Ocamlbuild", 
                                    Vernacextend.TyNonTerminal (Extend.TUopt (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))), (let coqpp_body opts
                                                            () = Vernactypes.vtdefault (fun () -> 
                                                                 
# 25 "plugin/coqsimpleio.mlg"
                                                           set_builder (Ocamlbuild (string_unopt opts))
                                                                 ) in fun opts
                                                            ?loc ~atts ()
                                                            -> coqpp_body opts
                                                            (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Builder", 
                                    Vernacextend.TyTerminal ("Dune", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUopt (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body s
                                                             opts
                                                             () = Vernactypes.vtdefault (fun () -> 
                                                                  
# 26 "plugin/coqsimpleio.mlg"
                                                               set_builder (Dune (s, string_unopt opts)) 
                                                                  ) in fun s
                                                             opts
                                                             ?loc ~atts ()
                                                             -> coqpp_body s
                                                             opts
                                                             (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Smart", 
                                    Vernacextend.TyTerminal ("On", Vernacextend.TyNil))), 
         (let coqpp_body () = Vernactypes.vtdefault (fun () -> 
# 27 "plugin/coqsimpleio.mlg"
                                smart_mode := true 
                              ) in fun ?loc ~atts ()
         -> coqpp_body (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Smart", 
                                    Vernacextend.TyTerminal ("Off", Vernacextend.TyNil))), 
         (let coqpp_body () = Vernactypes.vtdefault (fun () -> 
# 28 "plugin/coqsimpleio.mlg"
                                 smart_mode := false 
                              ) in fun ?loc ~atts ()
         -> coqpp_body (Attributes.unsupported_attributes atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("RunIO", 
                                    Vernacextend.TyTerminal ("Reset", 
                                    Vernacextend.TyNil)), (let coqpp_body () = 
                                                          Vernactypes.vtdefault (fun () -> 
                                                          
# 29 "plugin/coqsimpleio.mlg"
                           IOLib.reset () 
                                                          ) in fun ?loc ~atts ()
                                                          -> coqpp_body (Attributes.unsupported_attributes atts)), None))]

